; Copyright 1998 Paulo Jose de Matos Lopes Pinto & Pablo Oliveira Tavares
.MODEL SMALL
.STACK 5012                                  ; Para grandes expressoes
.DATA

VarList   DW 26 DUP (0)

; Variaveis usadas para o tratamento de erros
Error     DB ?                               ; Indica se houve erro
ErrorBuff DW ?                               ; Local para onde copiar a 
                                             ; mensagem de erro

; Implementacao de um vector de ponteiros para as mensagens de erro
ErrorMsg1 DB "Overflow",0
ErrorMsg2 DB "Divisao por 0",0
ErrorMsg3 DB "Erro de Sintaxe",0
ErrorList DW OFFSET ErrorMsg1, OFFSET ErrorMsg2, OFFSET ErrorMsg3
.CODE
INCLUDE util.inc 

;--------------------------------------
;| Rotinas publicas a outros modulos. |
;--------------------------------------
PUBLIC EvalExp


;-----------------------------------------
;| Constantes para as mensagens de erro. |
;-----------------------------------------
Overflow       = 0
Divide_By_Zero = 1
Sintax_Error   = 2

;------------------------------------------------------
;| Rotina: int EvalExp (char *StartPos)               |
;------------------------------------------------------
;| Recebe StartPos na stack.                          |
;| Inicia a analise da expressao que comeca em        |
;| ds:StartPos e devolve o resultado da expressao     |
;| nesse mesmo local.                                 |
;------------------------------------------------------

; Para Simplificar a percepcao da rotina
StartPos EQU WORD PTR [bp + 4]

EvalExp         PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   si

                mov    si, StartPos          ; Inicializa si e verifica se o
    IF01:       cmp    BYTE PTR [si], 0      ; buffer tem alguma coisa
                je     IF01_END
                mov    ErrorBuff, si         ; Inicializa o ponteiro para
                mov    Error, 0              ; onde sera colocada a mensagem de
                mov    bl, BYTE PTR [si]     ; erro
    IF02:       push   bx
                call   IsLetter
                cmp    ax, 1                 ; Ve se temos uma atribuicao
                jne    IF02_ELSE             ; a uma variavel
                cmp    BYTE PTR [si + 1], '='
                jne    IF02_ELSE
    IF02_THEN:  add    si, 2
                call   Expression            ; Atribui a variavel o valor
    IF03:       cmp    Error, 0
                jne    IF02_END
    IF03_THEN:  xor    bh, bh                ; calculado
                sub    bl, 'A'               
                shl    bl, 1                 ; Como sao words, bl = bl * 2   
                mov    VarList[bx], ax
    IF03_END:
                jmp    SHORT IF02_END
    IF02_ELSE:  call   Expression
    IF02_END:   
    IF04:       cmp    Error, 0
                jne    IF04_END
                push   ax
                mov    ax, StartPos
                push   ax
                call   Itoa
    IF04_END:
    IF01_END:
                pop    si
                pop    bp                    ; Restaura os registos e elimina
                ret    2                     ; Ptr da stack
EvalExp         ENDP

;------------------------------------------------------
;| Rotina: int Expression (void)                      |
;------------------------------------------------------
;| Analise a expressao no que diz respeito a somas e  |
;| subtraccoes.                                       |
;| Devolve em ax o valor obtido.                      |
;------------------------------------------------------

Expression      PROC
                push   bx                    ; Guarda os valores na stack
                push   cx

                call   Factor
    WHILE1:     cmp    Error, 0
                jne    WHILE1_END
                mov    bl, BYTE PTR [si]     ; Enquanto houver Factores
                cmp    bl, '+'
                je     WH1
                cmp    bl, '-'
                jne    WHILE1_END
    WH1:        inc    si
                mov    cx, ax
                call   Factor
    IF05:       cmp    Error, 0
                jne    IF05_END
    IF05_THEN:
    IF06:       cmp    bl, '+'               ; Se operacao for +  
                jne    IF06_THEN
                add    cx, ax                ; Faz a soma,
                jmp    SHORT IF06_END     
    IF06_THEN:  sub    cx, ax                ; Se nao faz a diferenca
    IF06_END:
    IF05_END:   
    IF07:       jno    IF07_ELSE             ; Ve se a ultima operacao
    IF07_THEN:  mov    bx, Overflow          ; deu overflow
                push   bx
                call   SysError
                jmp    SHORT IF07_END
    IF07_ELSE:  mov    ax, cx
    IF07_END:   jmp    SHORT WHILE1

    WHILE1_END:
    IF08:       cmp    Error, 1
                je     IF08_END
                cmp    bl, 0                 ; Ve se o caracter que terminou
                je     IF08_END              ; a leitura e o fim de string ou
                cmp    bl, ')'               ; o carater )
                je     IF08_END
    IF08_THEN:  mov    bx, Sintax_Error
                push   bx
                call   SysError
    IF08_END:
                pop    cx
                pop    bx                    ; Restaura os registos
                ret
Expression      ENDP


;------------------------------------------------------
;| Rotina: int Factor (void)                          |
;------------------------------------------------------
;| Analiza a expressao, no que diz respeito a multi-  |
;| plicacao e divisao de dois numeros.                |
;| Devolve em ax o valor obtido.                      |
;------------------------------------------------------

Factor          PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   bx
                push   cx
                push   dx

                call   Power                 ; Vai ver se existem Potencias
    WHILE2:     cmp    Error, 0              ; Enquanto houver Potencias
                jne    WHILE2_END
                mov    bl, BYTE PTR [si]     
                cmp    bl, '*'
                je     WH2
                cmp    bl, '/'
                jne    WHILE2_END
    WH2:        inc    si
                mov    cx, ax
                call   Power
    IF09:       cmp    Error, 0
                jne    IF09_END
    IF09_THEN:
    IF11:       cmp    bl, '*'               ; Se operacao for *  
                jne    IF11_THEN
                imul   cx                    ; Faz o produto,
                jmp    SHORT IF11_END     
    IF11_THEN:  
    IF12:       cmp    ax, 0                 ; Ve se estamos a tentar dividir
                je     IF12_ELSE             ; por 0   
    IF12_THEN:  mov    dx, ax                ; Se nao faz o quociente
                mov    ax, cx 
                mov    cx, dx
                xor    dx, dx
                idiv   cx                
                jmp    SHORT IF12_END
    IF12_ELSE:  mov    bl, Divide_By_Zero    ; Caso contrario da erro
                push   bx
                call   SysError
    IF12_END:
    IF11_END:
    IF09_END:   
    IF10:       jno    IF10_END              ; Se a ultima operacao deu
    IF10_THEN:  mov    bx, Overflow          ; overflow da erro
                push   bx
                call   SysError
    IF10_END:   jmp    SHORT WHILE2
    WHILE2_END:

                pop    dx                    ; Restaura os registos usados
                pop    cx
                pop    bx
                pop    bp                    
                ret                          
Factor          ENDP


;------------------------------------------------------
;| Rotina: int Power (void)                           |
;------------------------------------------------------
;| Analiza a expressao, no que diz respeito a poten-  |
;| cia.                                               |
;| Devolve em ax o valor obtido.                      |
;------------------------------------------------------

Power           PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   bx
                push   cx
                push   dx

                call   SignTerm              ; Vai ver se existem Termos
    WHILE3:     cmp    Error, 0              ; Enquanto houver Termos
                jne    WHILE3_END
                mov    bl, BYTE PTR [si]     
                cmp    bl, '^'
                jne    WHILE3_END
                inc    si
                mov    cx, ax
                call   SignTerm
                push   cx                    ; Calcula cx ^ ax   
                push   ax
                call   CalcPower
                jmp    SHORT WHILE3
    WHILE3_END:

                pop    dx                    ; Restaura os registos usados
                pop    cx
                pop    bx
                pop    bp                    
                ret                          
Power           ENDP

;------------------------------------------------------
;| Rotina: int SignTerm (void)                        |
;------------------------------------------------------
;| Analiza a expressao, no que diz respeito a sinais  |
;| de + e - antes de um termo                         |
;| Devolve em ax o valor obtido.                      |
;------------------------------------------------------

SignTerm        PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   bx
                push   cx
                push   dx

                mov    cx, 1
    IF13:       mov    bl, BYTE PTR [si]     
                cmp    bl, '+'
                jne    IF13_ELSE
    IF13_THEN:  inc    si
                jmp    SHORT IF13_END
    IF13_ELSE:
    IF14:       cmp    bl, '-'
                jne    IF14_END
                inc    si
                mov    cx, -1
    IF14_END:
    IF13_END:   call   Term
                imul   cx

                pop    dx                    ; Restaura os registos usados
                pop    cx
                pop    bx
                pop    bp                    
                ret                          
SignTerm        ENDP


;------------------------------------------------------
;| Rotina: int Term (void)                            |
;------------------------------------------------------
;| Analiza a expressao, no que diz respeito a numeros |
;| Devolve em ax o valor obtido.                      |
;------------------------------------------------------

Term            PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   bx
                push   dx

                mov    al, BYTE PTR [si]
    IF15:       push   ax
                call   IsDigit               ; Vai ver se e um digito   
                cmp    ax, 1
                jne    IF15_ELSE             ; Se for converte-o
    IF15_THEN:  push   si
                call   Atoi
    IF16:       cmp    dx, 0                 ; Se nao conseguiu converter
                jne    IF16_ELSE             ; todo o numero, assinala erro
    IF16_THEN:  mov    bx, Overflow
                push   bx
                call   SysError
                jmp    SHORT IF16_END
    IF16_ELSE:  mov    si, bx
    IF16_END:
                jmp    SHORT IF15_END
    IF15_ELSE:  mov    al, BYTE PTR [si]
    IF17:       cmp    al, '('               ; Se for antes um parentesis,
                jne    IF17_ELSE             ; analiza o que esta dentro deles
    IF17_THEN:  inc    si                   
                call   Expression          
                inc    si
                jmp    SHORT IF17_END
    IF17_ELSE:
                mov    bl, BYTE PTR [si]
    IF18:       push   bx
                call   IsLetter
                cmp    ax, 1                 ; Se for antes uma variavel, vai
                jne    IF18_ELSE             ; buscar o valor dela
                inc    si
                xor    bh, bh
                sub    bl, 'A'
                shl    bl, 1
                mov    ax, VarList[bx]
                jmp    SHORT IF18_END
    IF18_ELSE:  mov    bl, Sintax_Error      ; Caracter em posicao invalida
                push   bx                    ; implica um erro de sintaxe   
                call   SysError
    IF18_END:
    IF17_END:
    IF15_END:
                pop    dx                    ; Restaura os registos usados
                pop    bx
                pop    bp                    
                ret                          
Term            ENDP




;------------------------------------------------------
;| Rotina: int CalcPower (int X, int Y)               |
;------------------------------------------------------
;| Calcula o valor de X elevado a Y.                  |
;| Se Y < 0 o resultado e indeterminado.              |
;| Devolve em ax o valor obtido.                      |
;------------------------------------------------------

; Para Simplificar a percepcao da rotina
X EQU WORD PTR [bp + 6]
Y EQU WORD PTR [bp + 4]

CalcPower       PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   bx
                push   cx
                push   dx

                mov    ax, 1
    IF19:       test   Y, 8000h              ; Verifica se Y < 0, e em caso
                jnz    IF19_END              ; afirmativo considera X^Y = 1
    IF19_THEN:  mov    cx, Y
                mov    bx, X                 ; Ciclo for onde e feito
    FOR1:       jcxz   FOR1_END              ; X*X*X...X   Y vezes
                imul   bx
    IF20:       jno    IF20_END
    IF20_THEN:  mov    bx, Overflow          ; Se a ultima multiplicacao
                push   bx                    ; deu overflow, assinala erro
                call   SysError              ; e sai do ciclo, como se usasse
                jmp    SHORT FOR1_END        ; a instrucao break do C
    IF20_END:   loop   SHORT FOR1
    FOR1_END:
    IF19_END:

                pop    dx                    ; Restaura os registos usados
                pop    cx
                pop    bx
                pop    bp                    
                ret    4                     ; Elimina X e Y da stack
CalcPower       ENDP

;------------------------------------------------------
;| Rotina: void SysError (int ErrorValue)             |
;------------------------------------------------------
;| Rotina  de tratamento de erros.                    |
;------------------------------------------------------

; Para Simplificar a percepcao da rotina
ErrorValue EQU WORD PTR [bp + 4]

SysError        PROC
                push   bp                    ; Guarda os valores na stack
                mov    bp, sp
                push   bx
                push   cx
                push   di

                mov    Error, 1
                mov    bx, ErrorValue        ; Vai buscar o endereco da
                xor    bh, bh                ; mensagem
                shl    bx, 1
                mov    bx, ErrorList[bx]
                mov    di, ErrorBuff
    WHILE4:     cmp    BYTE PTR [bx], 0      ; Copia para o buffer de saida
                je     WHILE4_END            ; a mensagem de erro
                mov    cl, BYTE PTR [bx]
                mov    BYTE PTR [di], cl
                inc    bx
                inc    di
                jmp    SHORT WHILE4
    WHILE4_END: mov    BYTE PTR [di], 0

                pop    di
                pop    cx
                pop    bx
                pop    bp                    
                ret    2                     ; Elimina ErrorValue da stack
SysError        ENDP

END
