; Copyright 1998 Paulo Jose de Matos Lopes Pinto & Pablo Oliveira Tavares
.MODEL SMALL
.STACK 1024
.DATA
CalcPic      DB "ͻ$"
             DB "                                               $"
             DB "                                               $"
             DB " A B C D E F G H I   7 8 9  + -  E  xxxxxxyyyy $"
             DB " J K L M N O P Q R   4 5 6  * /  N  xx  xx  yy $"
             DB "  S T U V W X Y Z    1 2 3  ( )  T  xxxxxxyyyy $"
             DB "                       0     ^   E  xx  yy  zz $"
             DB "                      <--   =   R  zzzzzzzzzz $"
             DB "ͼ$"

ScreenBuffer DB 256 DUP (0)               ; Buffer das expressoes
StartPos     DW ?                         ; Ponteiro para o 1 caracter visivel
EndPos       DW ?                         ; Ponteiro para a posicao do 
                                          ; proximo caracter

Terminate    DB ?                         ; Indica se e para terminar o 
                                          ; programa
OldX         DB ?                         ; Posicao do cursor antes de 
OldY         DB ?                         ; correr o programa
OldScr       DW 445 DUP (?)               ; conteudo do local do ecran onde
                                          ; aparece a calculadora
.CODE
INCLUDE dos.inc
INCLUDE bios.inc
INCLUDE util.inc
INCLUDE exp.inc

;-------------------------------------------
;| Constantes para a manipulacao de dados. |
;-------------------------------------------
LineSize    = 50                          ; Largura da calculadora
ScreenSize  = 46                          ; Largura da janela da calculadora
BufferSize  = 256                         ; Dimensao do buffer das expressoes

K_Esc       = 27                          ; Codigo ascii do Esc
K_Backspace = 08                          ; Codigo ascii do Backspace
K_Enter     = 13                          ; Codigo ascii do Enter
K_Clear     = 174                         ; Codigo ascii do 


;------------------------------------------------------
;| Rotina: void DrawCalc (void)                       |
;------------------------------------------------------
;| Desenha a inteface calculadora.                    |
;------------------------------------------------------

; Para Simplificar a percepcao da rotina
Y    EQU BYTE PTR [bp - 1]
BPtr EQU WORD PTR [bp - 3]

DrawCalc        PROC
                push   bp                 ; Guarda os valores na stack
                mov    bp, sp             ; e guarda espaco para variaveis 
                sub    sp, 3              ; locais
                push   ax
                push   bx
                push   cx
                push   dx
                push   di
                push   si

                
                mov    Y, 10              ; Inicializa as variaveis locais
                mov    BPtr, OFFSET CalcPic
                mov    cx, 9

    FOR1:       @SetCurPos 17, Y          ; Desenha a calculadora
                @DispStr   BPtr
                inc    Y
                add    BPtr, LineSize
                loop   FOR1
                @SetCurPos 18, 11
                @PutChAtr ' ', 70h, 0, 47 ; Desenha a janela onde aparecem
                                          ; as expressoes

                pop    si                
                pop    di
                pop    dx                 ; Restaura os registos
                pop    cx
                pop    bx
                pop    ax
                add    sp, 3
                pop    bp
                ret
DrawCalc        ENDP


;------------------------------------------------------
;| Rotina: void DrawBuffer (void)                     |
;------------------------------------------------------
;| Escreve o conteudo do buffer que e visivel.        |
;------------------------------------------------------

; Para Simplificar a percepcao da rotina
X     EQU BYTE PTR [bp - 1]

DrawBuffer      PROC
                push   bp                 ; Guarda os valores na stack
                mov    bp, sp
                dec    sp
                push   ax                 
                push   bx
                push   dx

                mov    X, 18
                @SetCurPos X, 11
                mov    bx, StartPos
    WHILE1:     cmp    bx, EndPos         ; Desenha a parte visivel da 
                je     WHILE1_END         ; expressao
                mov    ax, bx
                sub    ax, StartPos
                cmp    ax, ScreenSize
                ja     WHILE1_END
                
                mov    al, BYTE PTR [bx]
                @DispCh al
                inc    bx
                inc    X
                jmp    SHORT WHILE1
    WHILE1_END: 
    
    WHILE2:     mov    ax, bx             ; Preenche o resto com espacos
                sub    ax, StartPos
                cmp    ax, ScreenSize
                ja     WHILE2_END
                
                @DispCh ' '
                inc    bx
                jmp    SHORT WHILE2
    WHILE2_END: @SetCurPos X, 11
                
                pop    dx                 ; Restaura os registos
                pop    bx
                pop    ax
                inc    sp
                pop    bp
                ret                       
DrawBuffer      ENDP



;------------------------------------------------------
;| Rotina: void ReadBuffer (void)                     |
;------------------------------------------------------
;| Le a expressao digitada pelo utilzador para o      |
;| buffer.                                            |
;------------------------------------------------------

; Para Simplificar a percepcao da rotina
Sair  EQU BYTE PTR [bp - 1]

ReadBuffer      PROC
                push   bp                 ; Guarda os valores na stack
                mov    bp, sp             ; e guarda espaco para variaveis 
                dec    sp                 ; locais
                push   ax
                push   bx
                push   cx
                push   dx

                
                mov    Sair, 0            ; Inicializa as variaveis usadas

    REPEAT1:    @GetKey 0, 0
    CASE1:      
    CASE1_1:    cmp    al, K_Clear        ; Se carregou em Ac, limpa o buffer
                jne    CASE1_2
                mov    StartPos, OFFSET ScreenBuffer
                mov    EndPos, OFFSET ScreenBuffer
                call   DrawBuffer
                jmp    CASE1_END

    CASE1_2:    cmp    al, K_Esc          ; Se carregou em Esc, sai da 
                jne    CASE1_3            ; aplicacao
                mov    Sair, 1
                mov    Terminate, 1
                jmp    CASE1_END

    CASE1_3:    cmp    al, K_BackSpace    ; Se carregou em Backspace, elimina
                jne    CASE1_4            ; o ultimo caracter existente no 
    IF01:       mov    bx, EndPos         ; buffer
                cmp    bx, OFFSET ScreenBuffer
                jbe    IF01_ELSE
    IF01_THEN:  dec    EndPos
    IF02:       mov    bx, EndPos
                cmp    bx, StartPos
                jne    IF02_END
                mov    bx, StartPos
                cmp    bx, OFFSET ScreenBuffer
                je     IF02_END
    IF02_THEN:  dec    StartPos
    IF02_END:   call   DrawBuffer
                jmp    SHORT IF01_END

    IF01_ELSE:  @DispCh 7
    IF01_END:   jmp    SHORT CASE1_END

    REPEAT1_1:  jmp    SHORT REPEAT1      ; Necessario porque existem mais de
                                          ; 127 bytes entre REPEAT1 e 
                                          ; UNTIL1_END

    CASE1_4:    cmp    al, K_Enter        ; Se carregou em Enter termina a
                jne    CASE1_ELSE         ; leitura
                mov    bx, EndPos
                mov    BYTE PTR [bx], 0
                mov    Sair, 1
                jmp    SHORT CASE1_END
    
    CASE1_ELSE: 
    IF03:       mov    bl, al             ; Se for uma tecla valida
                push   ax                 ;  e couber no buffer, acrescenta 
                call   IsDigit            ;  a tecla ao buffer
                cmp    ax, 1
                je     IF03_COND
                push   bx
                call   IsLetter 
                cmp    ax, 1
                je     IF03_COND
                push   bx
                call   IsOp
                cmp    ax, 1
                jne    IF03_END 
    IF03_COND:  mov    ax, bx             ; Pequena optimizacao em relacao a
                mov    bx, EndPos         ; condicao
                sub    bx, OFFSET ScreenBuffer
                cmp    bx, BufferSize - 1
                je     IF03_END
    IF03_THEN:  mov    bx, EndPos
                push   ax
                call   ToUpper
                mov    BYTE PTR [bx], al
                inc    EndPos
    IF04:       mov    bx, EndPos
                sub    bx, StartPos
                cmp    bx, ScreenSize
                jbe    IF04_END
    IF04_THEN:  inc    StartPos
    IF04_END:   call   DrawBuffer
    IF03_END:
    CASE1_END:
    UNTIL1_END: cmp    Sair, 1
                jne    REPEAT1_1


                pop    dx                 ; Restaura os registos
                pop    cx
                pop    bx
                pop    ax
                inc    sp
                pop    bp
                ret
ReadBuffer      ENDP

;------------------------------------------------------
;| Rotina: void RunCalc (void)                        |
;------------------------------------------------------
;| Controla o funcionamento da calculadora.           |
;------------------------------------------------------

RunCalc         PROC
                push   bx

                mov    Terminate, 0       ; Inicializa algumas variaveis
                call   DrawCalc           ; E coloca os ponteiro de maneira
    REPEAT2:    mov    StartPos, OFFSET ScreenBuffer
                mov    bx, StartPos       ; a apontar para o fim do texto do
    WHILE3:     cmp    BYTE PTR [bx], 0   ; resultado da ultima expressao
                je     WHILE3_END
                inc    bx
                jmp    SHORT WHILE3
    WHILE3_END: mov    EndPos, bx
                call   DrawBuffer
                call   ReadBuffer
    IF05:       cmp    Terminate, 0
                jne    IF05_END
    IF05_THEN:  mov    bx, OFFSET ScreenBuffer
                push   bx
                call   EvalExp
    IF05_END:
    UNTIL2_END: cmp    Terminate, 1
                jne    REPEAT2

                pop    bx
                ret                       
RunCalc         ENDP


;------------------------------------------------
;| Rotina: void SaveScreen (void)               |
;------------------------------------------------
;| Grava o local onde sera posta a calculadora. |
;------------------------------------------------

SaveScreen      PROC
                push   ds
                push   es                 ; Guarda os valores na stack
                push   ax
                push   bx
                push   cx
                push   dx
                push   si
                push   di


                
                mov    ax, ds             ; Inicializa es para o segmento
                mov    es, ax             ; de dados
                mov    ax, 0B800h         ; Inicializa ds para a memoria
                mov    ds, ax             ; video
                mov    di, OFFSET OldScr
                cld
                mov    bx, 10
    FOR2:       mov    ax, bx             ; Executa o calculo si = Y * 160 + X
                mov    si, 160
                mul    si
                add    ax, 34
                mov    si, ax
                mov    cx, 49
                mov    al, byte ptr [si+1]
                rep    movsw              ; Copia uma linha. 
                inc    bx                 
                cmp    bx, 19             
                jne    FOR2               
    FOR2_END:                           

                pop    di                 ; Restora os valores da stack
                pop    si
                pop    dx
                pop    cx
                pop    bx
                pop    ax
                pop    es
                pop    ds
                ret                       
SaveScreen      ENDP

;--------------------------------------------------
;| Rotina: void RestScreen (void)                 |
;--------------------------------------------------
;| Repoe o local onde estava posta a calculadora. |
;--------------------------------------------------

RestScreen      PROC
                push   es                 ; Guarda os valores na stack
                push   ax
                push   bx
                push   cx
                push   dx
                push   si
                push   di


                
                mov    ax, 0B800h         ; Inicializa es para a memoria
                mov    es, ax             ; video
                mov    si, OFFSET OldScr
                cld
                mov    bx, 10
    FOR3:       mov    ax, bx             ; Executa o calculo di = Y * 160 + X
                mov    di, 160
                mul    di
                add    ax, 34
                mov    di, ax
                mov    cx, 49
                rep    movsw              ; Copia uma linha. 
                inc    bx                 
                cmp    bx, 19             
                jne    FOR3               
    FOR3_END:                                      

                pop    di                 ; Restora os valores da stack
                pop    si
                pop    dx
                pop    cx
                pop    bx
                pop    ax
                pop    es
                ret                       
RestScreen      ENDP



;------------------------------------------------------
;| Local de arranque do codigo.                     |
;------------------------------------------------------


Start:          mov    ax, @DATA          ; Inicializa o segmento de dados
                mov    ds, ax

                @GetCur                   ; Guarda a posicao do cursor e 
                mov    OldX, dh           ; parte do ecran
                mov    OldY, dl
                call   SaveScreen

                call   RunCalc            ; Executa a calculadora

                call   RestScreen         ; Repoe o ecran e o cursor
                @SetCurPos OldY, OldX

                @Exit  0                  ; Sai com sucesso

END Start

